import sys, pygame, math, random
from pygame.locals import *
pygame.init()

size = width, height = 256*2*2,256*2
white = 255, 255, 255
black = 0, 0, 0
gray = 128, 128, 128
clock = pygame.time.Clock()
fullscreen = False
screen = pygame.display.set_mode(size)
pygame.display.set_caption("Sally Spelunker in CAVE EXPLORER")

ANIMATE_WALK = pygame.USEREVENT
SCROLL_EVENT = pygame.USEREVENT + 1
NEW_BEAT = pygame.USEREVENT + 2
GLOW_CHANGE = pygame.USEREVENT + 3
GLOW_DIRECTION = pygame.USEREVENT + 4
EXTRA_MOAN = pygame.USEREVENT + 5
SUPER_MOAN = pygame.USEREVENT + 6
PURGE = pygame.USEREVENT + 7

def double_size(image):
	image_object = pygame.image.load(image).convert_alpha()
	rect = image_object.get_rect()
	return pygame.transform.scale(image_object, (rect.width*2, rect.height*2))


tile_sprite = [ double_size("dark.png"), double_size("brown.png"), double_size("blue.png"), double_size("purple.png"), double_size("pink.png"), double_size("yellow.png") ]
tile_sprite_o = [ tile_sprite[0], tile_sprite[1], double_size("blue-o.png"), double_size("purple-o.png"), double_size("pink-o.png"), double_size("yellow-o.png") ]
water = double_size("water.png")
sounds = [ pygame.mixer.Sound("moan1.wav"), pygame.mixer.Sound("moan2.wav"), pygame.mixer.Sound("moan3.wav"), pygame.mixer.Sound("moan4.wav"), pygame.mixer.Sound("moan5.wav"), pygame.mixer.Sound("moan6.wav"), pygame.mixer.Sound("moan7.wav") ]
tense = pygame.mixer.Sound("supermoan.wav")
orgasm = pygame.mixer.Sound("ecstacy.wav")

big_text = pygame.font.Font("04B_25__.TTF", 72)
text = pygame.font.Font("04B_25__.TTF", 42)
small_text = pygame.font.Font("04B_25__.TTF", 32)
game_over_message_1 = text.render("Congratulations!", False, white)
game_over_message_2 = text.render("You've helped Sally get through her cavern!", False, white)
game_over_width_1 = text.size("Congratulations!")[0]
game_over_width_2 = text.size("You've helped Sally get through her cavern!")[0]

cool_drill = 0
scrollx = 0
beat = 2
jump_reset = True
game_over = False
map_data = [ ]

class Tile:
	def __init__(self, colour=0):
		self.colour = colour
		self.flooded = False
		self.o = False
	
	def draw(self, x, y):
		if not self.o:
			screen.blit(tile_sprite[self.colour], (x*32-scrollx, y*32))
		else:
			screen.blit(tile_sprite_o[self.colour], (x*32-scrollx, y*32))
		
		if self.colour == beat:
			glow.draw(x, y)
		
		if self.flooded:
			screen.blit(water, (x*32-scrollx, y*32))

class Glow:
	def __init__(self):
		self.index = 0
		self.li = [ ]
		self.direction = 1
			
		self.surface = pygame.Surface((32,32), SRCALPHA)
	
	def update(self):
		self.index += 1*self.direction
		self.index = max(self.index, 0)
		
		self.surface.fill((255,255,255,min(max(int(self.index/(255/float(70*16))),0),255)), None)
	
	def draw(self, x, y):
		screen.blit(self.surface, (x*32-scrollx, y*32))

class Girl:
	def __init__(self):
		self.x = width-180
		self.y = 32*5
		self.frame = 0
		self.images = [ double_size("girl.png"), double_size("girl2.png"), double_size("girl_jump.png") ]
		self.flip_images = [ pygame.transform.flip(self.images[0], True, False), pygame.transform.flip(self.images[1], True, False), pygame.transform.flip(self.images[2], True, False) ]
		self.direction = 1
		self.moving = False
		self.jumping = 0
		
	def draw(self):
		if self.direction > 0:
			li = self.images
		else:
			li = self.flip_images
	
		if self.jumping:
			screen.blit(li[2], (self.x, self.y))
		else:
			screen.blit(li[self.frame], (self.x, self.y))
	
	def animate(self):
		self.frame += 1
		if self.frame >= 2:
			self.frame = 0

glow = Glow()
ground = Tile(1)
girl = Girl()

def make_column(li=[]):
	if not li:
		li = [ ]
		for i in range(10):
			chance = random.randint(0,16)
			if chance < 4:
				li.append(Tile(map_data[len(map_data)-1][i+4].colour))
			elif chance < 8 and li:
				li.append(Tile(li[i-1].colour))
			else:
				li.append(Tile(random.randint(1,5)))
			
			if 3 < i < 8:
				if li[i].colour == 1:
					li[i] = Tile(random.randint(2,5))
			elif i < 3 or i > 8:
				if not random.randint(1,6):
					li[i] = ground

	new_li = [ ground, ground, ground ] + li + [ ground, ground,ground ]
	for i in range(len(new_li)):
		if i > 3:
			if new_li[i].colour != 1 and new_li[i-1].colour == 1 and new_li[i+1].colour == 1:
				new_li[i] = ground
	
	return new_li

for i in range(int(math.floor(width/32))-5):
	map_data.append(make_column([Tile(), Tile(), Tile(), Tile(), Tile(), Tile(), Tile(), Tile(), Tile(), Tile()]))
for i in range(int(math.floor(width/32))-5,int(math.floor(width/32))+20):
	map_data.append(make_column())
map_data[len(map_data)-1][-1],map_data[len(map_data)-1][-2],map_data[len(map_data)-1][-3],map_data[len(map_data)-1][-4],map_data[len(map_data)-1][-5] = Tile(4),Tile(3),Tile(2),Tile(5),Tile(4)
for i in range(int(math.floor(width/32))):
	map_data.append(make_column([ground, ground, ground, ground, ground, ground, ground, ground, ground, ground]))
	
#for x in map_data:
#	for y in x:
#		if y.colour > 1:
#			y.colour = 0

pygame.time.set_timer(SCROLL_EVENT, 80)
pygame.time.set_timer(NEW_BEAT, 70*16)
pygame.time.set_timer(GLOW_CHANGE, 1)
pygame.time.set_timer(GLOW_DIRECTION, (70*16)/2)
pygame.time.set_timer(PURGE, (70*16)/2)
pygame.time.set_timer(ANIMATE_WALK, 200)

def destroy_adjacent(x,y,iteration=0):
	global beat
	map_data[x][y].o = True
	if iteration == 4:
		pygame.time.set_timer(EXTRA_MOAN, 400)
	elif iteration == 7:
		pygame.time.set_timer(SUPER_MOAN, 700)
	
	iteration += 1
	
	if x > 0 and map_data[x-1][y].colour == beat and not map_data[x-1][y].o:
		destroy_adjacent(x-1,y,iteration)
	if map_data[x+1][y].colour == beat and not map_data[x+1][y].o:
		destroy_adjacent(x+1,y,iteration)
	if y > 0 and map_data[x][y-1].colour == beat and not map_data[x][y-1].o:
		destroy_adjacent(x,y-1,iteration)
	if y < len(map_data[x])-1 and map_data[x][y+1].colour == beat and not map_data[x][y+1].o:
		destroy_adjacent(x,y+1,iteration)

def flood_adjacent(x,y,recursed=True):
	if not map_data[x][y].colour:
		map_data[x][y].flooded = True
	
	if not recursed:
		if x > 0 and not map_data[x-1][y].colour and not map_data[x-1][y].flooded:
			flood_adjacent(x-1,y)
		if not map_data[x+1][y].colour and not map_data[x+1][y].flooded:
			flood_adjacent(x+1,y)
		if y > 0 and not map_data[x][y-1].colour and not map_data[x][y-1].flooded:
			flood_adjacent(x,y-1)
		if y < len(map_data[x])-1 and not map_data[x][y+1].colour and not map_data[x][y+1]:
			flood_adjacent(x,y+1)

def collide_x(direction):
	if direction < 0:
		return map_data[int(round((girl.x+scrollx-5)/32))][int(math.floor((girl.y+32-1)/32))].colour
	else:
		return map_data[int(round((girl.x+scrollx+16+5)/32))][int(math.floor((girl.y+32-1)/32))].colour

def collide_up():
	return map_data[int(math.floor((girl.x+scrollx)/32))][int(math.floor((girl.y-1)/32))].colour

def get_input():
	global cool_drill, scrollx, jump_reset, beat

	for event in pygame.event.get():
		if event.type is QUIT: 
			sys.exit()
		if event.type is SCROLL_EVENT:
			scrollx += 1
			girl.x -= 1
		if event.type is NEW_BEAT:
			beat += 1
			if beat > 5:
				beat = 2
		if event.type is GLOW_DIRECTION:
			glow.direction *= -1
		if event.type is GLOW_CHANGE:
			glow.update()
		if event.type is EXTRA_MOAN:
			pygame.time.set_timer(EXTRA_MOAN, 0)
			sounds[6].play()
		if event.type is SUPER_MOAN:
			pygame.time.set_timer(SUPER_MOAN, 0)
			tense.play()
		if event.type is PURGE:
			for x in range(len(map_data)):
				for y in range(len(map_data[x])):
					if map_data[x][y].o:
						map_data[x][y].colour = 0
		if event.type is ANIMATE_WALK and girl.moving:
			girl.animate()

	keystate = pygame.key.get_pressed()
	
	if (keystate[K_w] or keystate[K_a] or keystate[K_s] or keystate[K_d]) and not cool_drill:
		if keystate[K_s]:
			x,y = int(round((girl.x+scrollx+16)/32)),int(math.floor((girl.y+32)/32))
		elif keystate[K_d]:
			x,y = int(round((girl.x+scrollx+32)/32)),int(math.floor((girl.y+32-1)/32))
		elif keystate[K_a]:
			x,y = int(round((girl.x+scrollx-16)/32)),int(math.floor((girl.y+32-1)/32))
		elif keystate[K_w]:
			x,y = int(round((girl.x+scrollx+16)/32)),int(math.floor((girl.y+32-1)/32))-1
		else:
			return
		
		cool_drill = 10
		if map_data[x][y].colour == beat:
			destroy_adjacent(x,y)
			random.choice(sounds).play()
	else:
		if keystate[K_UP] :
			if map_data[int(math.floor((girl.x+scrollx)/32))][int(math.floor(girl.y/32))+1].colour and jump_reset:
				girl.jumping = 32*3
				jump_reset = False
		else:
			jump_reset = True
		if keystate[K_LEFT]:
			if not collide_x(-1):
				girl.x -= 5
			girl.direction = -1
			girl.moving = True
		elif keystate[K_RIGHT]:
			if not collide_x(1):
				girl.x += 5
			girl.direction = 1
			girl.moving = True
		else:
			girl.frame = 0
			girl.moving = False
	
	if keystate[K_ESCAPE]:
		sys.exit()
	if keystate[K_RETURN] and (keystate[K_LALT] or keystate[K_RALT]):
		global fullscreen
		if not fullscreen:
			screen = pygame.display.set_mode(size, pygame.FULLSCREEN)
			fullscreen = True
		else:
			screen = pygame.display.set_mode(size)
			fullscreen = None

on_menu = True
hard_mode = False
while on_menu:
	clock.tick(30)
	screen.fill(black)
	screen.blit(text.render("Sally Spelunker in...", False, white), (20, 20))
	screen.blit(big_text.render("CAVE EXPLORER", False, white), (20, 60))
	screen.blit(small_text.render("When Sally gets lonely, she", False, white), (width/2+20, 20))
	screen.blit(small_text.render("likes to explore the depths", False, white), (width/2+20, 20+30))
	screen.blit(small_text.render("of her cavern!", False, white), (width/2+20, 20+60))
	screen.blit(small_text.render("Massage glowing blocks with", False, white), (width/2+20, 150))
	screen.blit(small_text.render("WASD, and move with the arrow", False, white), (width/2+20, 150+30))
	screen.blit(small_text.render("keys to help Sally get to", False, white), (width/2+20, 150+60))
	screen.blit(small_text.render("the end, and make her feel", False, white), (width/2+20, 150+90))
	screen.blit(small_text.render("less lonely!", False, white), (width/2+20, 150+120))
	
	if hard_mode:
		easy_select = black
		hard_select = gray
	else:
		easy_select = gray
		hard_select = black
	screen.blit(text.render("easy mode", False, white, easy_select), (80, height-120))
	screen.blit(text.render("hard mode", False, white, hard_select), (700, height-120))
	
	pygame.display.flip()
	
	for event in pygame.event.get():
		if event.type is QUIT: 
			sys.exit()
	keystate = pygame.key.get_pressed()
	if keystate[K_LEFT]:
		hard_mode = False
	elif keystate[K_RIGHT]:
		hard_mode = True
	if keystate[K_RETURN] and (keystate[K_LALT] or keystate[K_RALT]):
		if not fullscreen:
			screen = pygame.display.set_mode(size, pygame.FULLSCREEN)
			fullscreen = True
		else:
			screen = pygame.display.set_mode(size)
			fullscreen = None
	elif keystate[K_RETURN]:
		on_menu = False
	if keystate[K_ESCAPE]:
		sys.exit()

if hard_mode:
	pygame.time.set_timer(SCROLL_EVENT, 80/3)
	pygame.time.set_timer(NEW_BEAT, 70*16/2)
	pygame.time.set_timer(GLOW_DIRECTION, (70*16)/4)
	pygame.time.set_timer(PURGE, (70*16)/4)

while True:
	clock.tick(60)
	
	for x in range(len(map_data)):
		for y in range(len(map_data[x])-1):
			if map_data[x][y].colour != 1 and not map_data[x][y+1].colour:
				empty = map_data[x][y+1]
				map_data[x][y+1] = map_data[x][y]
				map_data[x][y] = empty
	
	get_input()
	
	if cool_drill:
		cool_drill -= 1
		
	for x in range(len(map_data)):
		for y in range(len(map_data[x])):
			map_data[x][y].draw(x,y)
	girl.draw()
	
	if not game_over:
		if girl.jumping:
			if not collide_up():
				girl.y -= 8
			girl.jumping -= 8
		elif girl.y+48 > height:
			game_over = True
			flood_adjacent(int(round((girl.x+scrollx+8)/32)),int(math.floor((girl.y+32)/32)), False)
			orgasm.play()
		elif not map_data[int(round((girl.x+scrollx+8)/32))][int(math.floor((girl.y+32)/32))].colour:
			girl.y += 4
	else:
		if math.ceil((scrollx+width)/32) < len(map_data):
			scrollx += 1
		else:
			screen.blit(game_over_message_1, (width/2-game_over_width_1/2, height/2-20))
			screen.blit(game_over_message_2, (width/2-game_over_width_2/2, height/2+30))
			scrollx = len(map_data)*32
			
			
		for x in range(len(map_data)):
			for y in range(len(map_data[x])):
				if map_data[x][y].flooded:
					flood_adjacent(x, y, False)
		if not collide_x(-1):
			girl.x -= 5
		elif not collide_up():
			girl.y -= 8
	
	pygame.display.flip()